! asm  -  assemble a virtual machine instruction

      subroutine asm (str)
      character*(*)      str
      #include           global.def
      #include           vm.mac
      #include           options.cmn
      #include           perror.cmn
      #include           vstate.cmn
      integer            p, i, atoi, t, asmscan, opcode
      real               atof
      integer            iop
      real               rop
      logical            lop
      equivalence        (iop, rop)
      equivalence        (iop, lop)
      character*(MAXSTR) cat, itoa, token
      character*40       buffer

      p = 1
! get opcode mnemonic
      opcode = asmscan (token,str,p)
      if (opcode .eq. ASMERROR) then
         call fputstr (STDERR, 'invalid opcode: '//str)
         call fputstr (STDERR, '   at pc = '//cat(itoa(pc),EOL))
         errcount = errcount + 1
         return
      end if
! get operand if any
      t = asmscan (token,str,p)
      if (t .eq. ASMERROR) then      !one word instruction
         if (codeflag) write (buffer,'(2i12)') pc, opcode
         mem(pc) = opcode
         pc = pc + 1
      else
         if (t .eq. _true) then
            lop = .true.
         else if (t .eq. _false) then
            lop = .false.
         else if (t .eq. _intnum) then
            iop = atoi(token)
         else if (t .eq. _realnum) then
            rop = atof(token)
         else
            call fputstr (STDERR, 'invalid instruction: '//str)
            call fputstr (STDERR, '   at pc = '//cat(itoa(pc),EOL))
            do i = 1, p + 20
               call fputc (STDERR, BLANK)
            end do
            call fputstr (STDERR, '^'//EOL)
            errcount = errcount + 1
            return
         end if
         if (codeflag) write (buffer,'(3i12)') pc, opcode, iop
         mem(pc) = opcode
         mem(pc+1) = iop
         pc = pc + 2
      end if
      if (codeflag) then
         call fputstr (STDOUT, buffer//str)
         call fputc (STDOUT, NEWLINE)
      end if

      return
      end
