! asm.lex  -  lexgen input for virtual machine assembler
#include  vm.mac

! opcodes
_add_i   = add
_add_r   = add\[r\] 
_sub_i   = sub
_sub_r   = sub\[r\]
_mult_i  = mult
_mult_r  = mult\[r\]
_div_i   = div
_div_r   = div\[r\]
_pwr_i   = pwr
_pwr_r   = pwr\[r\]
_neg_i   = neg
_neg_r   = neg\[r\]
_eq_i    = eq
_eq_r    = eq\[r\]
_ne_i    = ne
_ne_r    = ne\[r\]
_gt_i    = gt
_gt_r    = gt\[r\]
_ge_i    = ge
_ge_r    = ge\[r\]
_lt_i    = lt
_lt_r    = lt\[r\]
_le_i    = le
_le_r    = le\[r\]
_and     = and 
_or      = or 
_not     = not
_mark    = mark
_markl   = markl
_call    = call
_rtn     = rtn
_rtns    = rtns
_alloc   = alloc
_calloc  = calloc
_halt    = halt
_push    = push
_push_r  = push\[r\]
_push_l  = push\[l\]
_pushl   = pushl
_pushlc  = pushlc
_pushf   = pushf
_pop     = pop
_asnv    = asnv
_asna    = asna
_asns    = asns
_val     = val
_val2    = val2
_ixa     = ixa
_readln  = readln
_read_i  = read   
_read_r  = read\[r\]
_read_l  = read\[l\]
_read_s  = read\[s\]
_print_i = print  
_print_r = print\[r\]
_print_l = print\[l\]
_print_s = print\[s\]
_jt      = jt 
_jf      = jf 
_jmp     = jmp    
_flt     = flt
_flt2    = flt2
_int     = int
_int2    = int2
_sin     = sin    
_cos     = cos    
_tan     = tan    
_asin    = asin
_acos    = acos
_atan    = atan
_exp     = exp    
_log     = log    
_abs_i   = abs    
_abs_r   = abs\[r\]
_cat     = cat
_indx    = indx
_chr     = chr
_ord     = ord
_eqs     = eqs
_substr  = substr
_len     = len

! assembler directives
_org     = org
_fporg   = fporg
_bporg   = bporg
_ascii   = ascii
_word_i  = word
_word_r  = word\[r\]
_word_l  = word\[l\]
_entry   = entry

! constants
#define  dec_num  ([0-9]{[0-9]}.{[0-9]} | {[0-9]}.[0-9]{[0-9]})
_intnum  = [0-9]{[0-9]}
_realnum = (dec_num | dec_num (e|E)(+|-|) [0-9]{[0-9]})
_true    = true
_false   = false
! all printable characters except quote
#define  pnq   ([\\h20-\\h26]|[\\h28-\\h7E])
_string  =  ' {pnq} ' { '{pnq}' }
! identifiers for linker entries
_id      = ( [a-z] | [A-Z] ) { ( [a-z] | [A-Z] | [0-9] | $ | _ ) }
