! declist  -  parse declaration statements and define symbols
! <def> := id | id ( intnum )
! <declist> ::= <def> | <def> , <declist> eol

      subroutine declist (table, t)
      integer            table, t
      #include           global.def
      #include           spl.mac
      logical            reflocal, extrnflag, dummyflag
      integer            lex, type, asize, atoi
      integer            attr (NATTR), dummyattr (NATTR)
      character*(MAXSTR) id, token

      extrnflag = .false.
      if (t .eq. $extrn) then
         type = lex(t,token)
         extrnflag = .true.
      else
         type = t
      end if
      if (type .eq. $int) then
         attr(IDTYPE) = INTTYPE
      else if (type .eq. $real) then
         attr(IDTYPE) = REALTYPE
      else if (type .eq. $log) then
         attr(IDTYPE) = LOGTYPE
      else if (type .eq. $char) then
         attr(IDTYPE) = STRTYPE
      else
         call perror ('unknown data type'//NULL)
      end if

      do while (t .ne. $eol)
         t = lex (t,token)
         if (t .ne. $id) then
            call perror ('declaration error: id expected'//NULL)
         else
            id = token
            if (table .eq. LOCAL) then
               dummyattr(IDSCOPE) = LOCAL
               if (reflocal(id,dummyattr)) then
                  if (dummyattr(IDSCOPE) .eq. DUMMY) then
                     dummyflag = .true.
                     if (dummyattr(IDTYPE) .ne. BOGUSTYPE) then
                        call perror ('multiple argument declaration'//NULL)
                     end if
                  else
                     call perror ('multiple name declaration'//NULL)
                  end if
               else
                  dummyflag = .false.
               end if
            end if
            if (lex(t,token) .eq. $lparen) then   !array declaration
               if (lex(t,token) .eq. $intnum) then
                  asize = atoi(token)
                  if (lex(t,token) .eq. $rparen) then
                     t = lex (t,token)
                     if (t .ne. $comma .and. t .ne. $eol) then
                        call perror ('comma or end of line expected'//NULL)
                     end if
                  else
                     call perror ('missing parentheses'//NULL)
                  end if
               else
                  call perror ('integer constant expected'//NULL)
               end if
               if (type .eq. $char) then
                  if (extrnflag) then
                     attr(IDCLASS) = FUNCTION_ID
                  else
                     attr(IDCLASS) = STRING_ID
                  end if
                  attr(IDSIZE) = asize + 1
               else
                  attr(IDCLASS) = ARRAY_ID
                  attr(IDSIZE) = asize
               end if
            else if (t .eq. $comma .or. t .eq. $eol) then !scalar declaration
               if (extrnflag) then
                  attr(IDCLASS) = FUNCTION_ID
                  if (type .eq. $char) then
                     attr(IDSIZE) = 2
                  else
                     attr(IDSIZE) = 1
                  end if
               else
                  if (type .eq. $char) then
                     attr(IDCLASS) = STRING_ID
                     attr(IDSIZE) = 2
                  else
                     attr(IDCLASS) = IDENTIFIER
                     attr(IDSIZE) = 1
                  end if
               end if
            end if
            ! install in table
            if (table .eq. LOCAL) then
               if (dummyflag) then
                  attr(IDSCOPE) = DUMMY
                  call moddummy (id, attr)
               else
                  attr(IDSCOPE) = LOCAL
                  call deflocal (id, attr)
               end if
            else
               attr(IDSCOPE) = GLOBAL
               call defglobal (id, attr)
            end if
         end if
      end do

      return
      end
