! parse  -  main parsing routine

      logical function parse (basefp, basebp)
      integer            basefp, basebp
      #include           global.def
      #include           spl.mac
      #include           perror.cmn
      #include           vstate.cmn
      #include           parse.cmn
      character*(MAXSTR) token, itoa, cat
      integer            t, lex, allocarg, functype
      integer            localsize, globalsize, localchr, globalchr
      logical            inunit

      pc = ORIGIN
      ccp = CHAR_ORIGIN
      allocarg = 1
      inunit = .false.
      do while (lex(t,token) .ne. $eof)
         if (t .eq. $prog) then                  !program name
            if (inunit) then
               call perror 
     &         ('program occurs within another program unit'//NULL)
            else
               inunit = .true.
            end if
            call initlocal ()
            allocarg = pc + 1
            call asm ('alloc 0'//NULL)
            call asm ('calloc 0'//NULL)
            nsp = 0
            do while (lex(t,token) .ne. $eol)
               continue
            end do
         else if (t .eq. $endprog) then          !end program
            call asm ('halt'//NULL)
            if (inunit) then
               inunit = .false.
            else
               call perror 
     &         ('END PROGRAM occurs outside any program unit'//NULL)
            end if
            mem(allocarg) = localsize()
            mem(allocarg+2) = localchr()
            do while (nsp .gt. 0)
               if (nest(nsp) .eq. $if) then
                  call perror ('unclosed if block'//NULL)
               else if (nest(nsp) .eq. $while) then
                  call perror ('unclosed while loop'//NULL)
               else if (nest(nsp) .eq. $until) then
                  call perror ('unclosed repeat loop'//NULL)
               end if
               nsp = nsp - 1
            end do
            if (lex(t,token) .ne. $eol) then
               call perror ('unexpected text after valid stmt'//NULL)
               do while (lex(t,token) .ne. $eol)
                  continue
               end do
            end if
         else if (t .eq. $intfunc .or. t .eq. $realfunc .or. 
     &            t .eq. $logfunc .or. t .eq. $charfunc) then
            if (inunit) then
               call perror 
     &          ('function appears within another program unit'//NULL)
            else
               inunit = .true.
            end if
            call initlocal ()
            nsp = 0
            if (t .eq. $intfunc) functype = INTTYPE
            if (t .eq. $realfunc) functype = REALTYPE
            if (t .eq. $logfunc) functype = LOGTYPE
            if (t .eq. $charfunc) functype = STRTYPE
            t = lex(t,token)
            call linkdef(token, pc)
            allocarg = pc + 1
            call asm ('alloc 0'//NULL)
            call asm ('calloc 0'//NULL)
            if (lex(t,token) .eq. $lparen) then
               call arglist (t)
               if (t .ne. $rparen) then
                  call perror ('right parenthesis expected'//NULL)
               end if
               if (t .ne. $eol) then
                  do while (lex(t,token) .ne. $eol)
                     call perror 
     &               ('unexpected characters after valid statement'//NULL)
                  end do
               end if
            end if
         else if (t .eq. $endfunc) then
            if (inunit) then
               inunit = .false.
            else
               call perror 
     &         ('END FUNCTION occurs outside any program unit'//NULL)
            end if
            mem(allocarg) = localsize()
            mem(allocarg+2) = localchr()
            do while (nsp .gt. 0)
               if (nest(nsp) .eq. $if) then
                  call perror ('unclosed if block'//NULL)
               else if (nest(nsp) .eq. $while) then
                  call perror ('unclosed while loop'//NULL)
               else if (nest(nsp) .eq. $until) then
                  call perror ('unclosed repeat loop'//NULL)
               end if
               nsp = nsp - 1
            end do
            if (lex(t,token) .ne. $eol) then
               call perror ('unexpected text after valid stmt'//NULL)
               do while (lex(t,token) .ne. $eol)
                  continue
               end do
            end if
         else if (t .eq. $asm) then
            call asm (token)
         else
            if (inunit) then
               call stmtparse (t,token,functype)
            else if (t .eq. $int .or. t .eq. $real .or. 
     &               t .eq. $log .or. t .eq. $char) then
               call declist (GLOBAL, t)
            else
               call perror ('unknown statement outside program unit'//NULL)
            end if
         end if
      end do

      basefp = globalsize ()          !initial frame pointer
      basebp = globalchr ()           !initial buffer pointer
      if (errcount .gt. 0) then
         call fputstr (STDERR, cat(itoa(errcount), ' parse errors'//EOL))
         parse = .false.
      else
         parse = .true.
      end if

      return
      end
