! spl  -  simple programming language

      program spl
      #include           global.def
      #include           options.cmn
      integer            argc, fopen, u, i, j, basefp, basebp
      character*(MAXSTR) argv (MAXARGS), infile, upper
      logical            ok, parse, vasm, vlink, fnflag

      call ioinit ()
      call getargs (argc, argv)
      fnflag = .false.
      listflag = .false.
      codeflag = .false.
      traceflag = .false.
      asmflag = .false.
      do i = 1, argc
         j = index (argv(i), NULL)
         if (argv(i)(1:1) .eq. QUALIFIER) then
            argv(i) = upper(argv(i))
            if (index(argv(i)(2:j),'L') .gt. 0) listflag = .true.
            if (index(argv(i)(2:j),'M') .gt. 0) codeflag = .true.
            if (index(argv(i)(2:j),'T') .gt. 0) traceflag = .true.
            if (index(argv(i)(2:j),'A') .gt. 0) asmflag = .true.
         else
            if (fnflag) then
               call fputstr (STDERR,'syntax: spl [infile] [-options]'//EOL)
               call fputstr (STDERR,'options: -L   produce listing'//EOL)
               call fputstr (STDERR,'         -M   list machine code'//EOL)
               call fputstr (STDERR,'         -T   trace execution'//EOL)
               call fputstr (STDERR,'         -A   assembler input'//EOL)
               stop ' '
            else
               fnflag = .true.
               if (index(argv(i)(1:j), '.') .gt. 0) then
                  infile = argv(i)
               else
                  infile = argv(i)(1:j-1) // '.SPL' // NULL
               end if
            end if
         end if
      end do

      if (fnflag) then
         if (fopen (u, infile, IOREAD) .eq. IOERROR) then
            call fputstr (STDERR, 'cannot open '//infile)
            call fputstr (STDERR, ' for input'//EOL)
            stop 'aborted.'
         end if
      else
         u = STDIN
      end if
      call ppinit (u)
      call initglobal ()
      call initlink ()
      call initfunc ()

      if (asmflag) then
         ok = vasm (basefp, basebp)
      else
         ok = parse (basefp, basebp)
      end if

      if (ok) then
         if (vlink ()) then
            call vexec (basefp, basebp)
         else
            stop 'aborted.'
         end if
      else
         stop 'aborted.'
      end if

      end
