!  spl.lex  -  lexical analyzer input for spl
#include spl.mac

! keywords
$prog      = program
$endprog   = end {\b} program
$realfunc  = real {\b} function
$intfunc   = integer {\b} function
$logfunc   = logical {\b} function
$charfunc  = character {\b} function
$endfunc   = end {\b} function
$int       = integer
$real      = real
$log       = logical
$char      = character
$extrn     = external
$if        = if
$elseif    = else {\b} if
$else      = else
$endif     = end {\b} if
$while     = while
$endwhile  = end {\b} while
$repeat    = repeat
$until     = until
$read      = read
$print     = print
$return    = return
$asm       = asm

! arithmetic and logical operators
$add       =  +
$sub       =  -
$mult      =  *
$div       =  /
$pwr       =  **
$eq        =  ==
$ne        =  <>
$gt        =  >
$ge        =  >=
$lt        =  <
$le        =  <=
$and       =  and
$or        =  or
$not       =  not
$assign    =  =

! identifiers and constants
$intnum    = [0-9] { [0-9] }
#define  dec_num  ([0-9]{[0-9]}.{[0-9]} | {[0-9]}.[0-9]{[0-9]})
$realnum   = (dec_num | dec_num (e|E) (+|-|) [0-9]{[0-9]})
$true      = true
$false     = false
$id        = ( [a-z] | [A-Z] ) { ( [a-z] | [A-Z] | [0-9] | $ | _ ) }
! all printable characters except quote
#define    pnq   ([\\h20-\\h26]|[\\h28-\\h7E])
$string    =  ' {pnq} ' { '{pnq}' }

! punctuation
$lparen    =  \(
$rparen    =  \)
$comma     =  ,
$tilde     =  ~
$eol       =  \n
