! vasm  -  virtual machine assembler

      logical function vasm (basefp, basebp)
      integer            basefp, basebp
      #include           global.def
      #include           vm.mac
      #include           perror.cmn
      #include           vstate.cmn
      integer            t, startp, asmscan, atoi, addr, i, j
      character*(MAXSTR) token, itoa, doescape
      logical            done, found, is_sval, getlogline
      real               atof

      integer            MAXLABEL         !max # stmt labels
      parameter          (MAXLABEL = 128)
      integer            def (MAXLABEL), defpc (MAXLABEL), d
      integer            ref(MAXLABEL), refpc (MAXLABEL), r

      pc = ORIGIN
      basefp = 1
      basebp = 1
      d = 0
      r = 0

      do while (getlogline(line))
         llp = 1
         startp = 1
         t = asmscan(token, line, llp)
         if (t .eq. _intnum) then            !get label if present
            d = d + 1
            def(d) = atoi(token)
            defpc(d) = pc
            startp = llp
            t = asmscan(token, line, llp)
         end if
         if (t .eq. _entry) then
            if (asmscan(token,line,llp) .eq. _id) then
               call linkdef (token,pc)
            else
               call perror ('function name expected'//NULL)
            end if
         else if (t .eq. _call) then
            if (asmscan(token,line,llp) .eq. _id) then
               call linkref (token,pc+1)
            else
               call perror ('function name expected'//NULL)
            end if
            call asm ('call 0'//NULL)
         else if (t .eq. _ascii) then
            if (asmscan(token,line,llp) .eq. _intnum) then
               i = atoi(token)
               if (is_sval(token,line,llp)) then
                  token = doescape(token)
                  j = index(token,NULL)
                  cmem(i:i+j-1) = token(1:j)
               else
                  call perror ('string expected'//NULL)
               end if
            else
               call perror ('character address expected'//NULL)
            end if
         else if (t .eq. _word_i) then
            if (asmscan(token,line,llp) .eq. _intnum) then
               addr = atoi(token)
               do while (asmscan(token,line,llp) .eq. _intnum)
                  mem(addr) = atoi(token)
                  addr = addr + 1
               end do
            else
               call perror ('start address expected'//NULL)
            end if
         else if (t .eq. _word_r) then
            if (asmscan(token,line,llp) .eq. _intnum) then
               addr = atoi(token)
               do while (asmscan(token,line,llp) .eq. _realnum)
                  rmem(addr) = atof(token)
                  addr = addr + 1
               end do
            else
               call perror ('start address expected'//NULL)
            end if
         else if (t .eq. _word_l) then
            if (asmscan(token,line,llp) .eq. _intnum) then
               addr = atoi(token)
               done = .false.
               do while (.not. done)
                  t = asmscan(token,line,llp)
                  if (t .eq. _true) then
                     lmem(addr) = .true.
                  else if (t .eq. _false) then
                     lmem(addr) = .false.
                  else
                     done = .true.
                  end if
                  addr = addr + 1
               end do
            else
               call perror ('start address expected'//NULL)
            end if
         else if (t .eq. _jt .or. t .eq. _jf .or. t .eq. _jmp) then
            if (asmscan(token, line, llp) .eq. _intnum) then
               r = r + 1
               ref(r) = atoi(token)
               refpc(r) = pc + 1
               if (t .eq. _jt)  call asm ('jt 0'//NULL)
               if (t .eq. _jf)  call asm ('jf 0'//NULL)
               if (t .eq. _jmp) call asm ('jmp 0'//NULL)
            else
               call perror ('integer target label expected'//NULL)
            end if
         else if (t .eq. _org .or. t .eq. _fporg .or. t .eq. _bporg) then
            if (asmscan (token, line, llp) .eq. _intnum) then
               if (t .eq. _org)   pc = atoi(token)
               if (t .eq. _fporg) basefp = atoi(token)
               if (t .eq. _bporg) basebp = atoi(token)
            else
               call perror ('integer origin value expected'//NULL)
            end if
         else
            llp = index(line,NEWLINE) - 1
            call asm (line(startp:llp)//NULL)
         end if
      end do

! resolve all label references
      do i = 1, r
         j = 1
         found = .false.
         do while (.not. found .and. j .le. d)
            if (ref(i) .eq. def(j)) then
               found = .true.
               mem(refpc(i)) = defpc(j)
            end if
            j = j + 1
         end do
         if (.not. found) then
            call fputstr (STDERR, 'unresolved ref to label '//itoa(ref(i)))
            call fputc (STDERR, NEWLINE)
            errcount = errcount + 1
         end if
      end do

      vasm = (errcount .eq. 0)
      return
      end
