$! f  -  invoke VAX Fortran compiler
$!
$!  options:  L - produce listing
$!            O - optimize object code
$!            D - produce debugger object code
$!            P - preprocess source file
$!            S - save preprocessor output
$!            unrecognized options are ignored
$!
$ if p1 .eqs. "" then inquire p1 "source file"
$ if p1 .eqs. "" then exit
$
$! initialize file name
$ filename := 'p1'
$
$! initialize command string
$ cmdstr := fort -
            /nooptimize -
            /check=(bounds, overflow, nounderflow) -
            /extend_source -
            /warnings=(general,declarations)
$
$! delflag = 1 if temporary file is to be deleted
$   delflag = 0
$
$ if p2 .eqs. "" then goto exec
$ length = f$length(p2)
$
$! if L, O or D qualifier is present in p2, append to command string
$   if (f$locate("L",p2) .ne. length) then cmdstr := 'cmdstr'/list
$   if (f$locate("O",p2) .ne. length) then cmdstr := 'cmdstr'/opt
$   if (f$locate("D",p2) .ne. length) then cmdstr := 'cmdstr'/debug
$
$! if -P qualifier is present in p2, output prep to temporary file
$   if (f$locate("P",p2) .eq. length) then goto exec
$   filename := "PREPTEMP"
$   prep 'p1'.for preptemp.for
$   cmdstr := 'cmdstr'/object='p1'.obj
$   if (f$locate("S",p2) .eq. length) then delflag = 1
$
$ exec:
$   'cmdstr' 'filename'
$   if (delflag .eq. 1) then delete preptemp.for;*
$ exit
