! declist  -  parse declaration statements and define symbols
! <def> := id | id ( intnum )
! <declist> ::= <def> | <def> , <declist> eol

      subroutine declist (t)
      integer            t
      #include           global.def
      #include           spl.mac
      integer            lex, type, asize, atoi
      integer            attr (NATTR), dummyattr (NATTR)
      logical            symref
      character*(MAXSTR) id, token

      type = t
      if (type .eq. $int) then
         attr(IDTYPE) = INTTYPE
      else if (type .eq. $real) then
         attr(IDTYPE) = REALTYPE
      else if (type .eq. $log) then
         attr(IDTYPE) = LOGTYPE
      else if (type .eq. $char) then
         attr(IDTYPE) = STRTYPE
      else
         call perror ('unknown data type'//NULL)
      end if

      do while (t .ne. $eol)
         t = lex (t,token)
         if (t .ne. $id) then
            call perror ('declaration error: id expected'//NULL)
         else
            id = token
            if (symref(id,dummyattr)) then
               call perror ('multiple name declaration'//NULL)
            end if
            if (lex(t,token) .eq. $lparen) then   !array declaration
               if (lex(t,token) .eq. $intnum) then
                  asize = atoi(token)
                  if (lex(t,token) .eq. $rparen) then
                     t = lex (t,token)
                     if (t .ne. $comma .and. t .ne. $eol) then
                        call perror ('comma or end of line expected'//NULL)
                     end if
                  else
                     call perror ('missing parentheses'//NULL)
                  end if
               else
                  call perror ('integer constant expected'//NULL)
               end if
               if (type .eq. $char) then
                  attr(IDCLASS) = STRING_ID
                  attr(IDSIZE) = asize + 1
               else
                  attr(IDCLASS) = ARRAY_ID
                  attr(IDSIZE) = asize
               end if
            else if (t .eq. $comma .or. t .eq. $eol) then !scalar declaration
               if (type .eq. $char) then
                  attr(IDCLASS) = STRING_ID
                  attr(IDSIZE) = 2
               else
                  attr(IDCLASS) = IDENTIFIER
                  attr(IDSIZE) = 1
               end if
            end if
            call symdef (id, attr)            ! install in table
         end if
      end do

      return
      end
