! dodef  -  get macro name and replacement text

      subroutine dodef (line, lp)
      character*(*)       line
      integer             lp
      include             'global.def'
      include             'macscan.cmn'
      character*(MAXSTR)  name, def, ident
      character*(MAXSTR)  nametable         !storage for argument names
      integer             nameptr (MAXARGS) !pointers to argument names
      integer             ntp               !next free loc in nametable
      integer             endp, defp, argno, argcount, i
      logical             is_ident, done, found, equal, mkdef
      character*1         escchar, c

! get name and arguments
      argcount = 0
      ntp = 1
      if (is_ident(name, line, lp)) then
         if (line(lp:lp) .eq. '(') then  !collect argument names
            lp = lp + 1
            done = .false.
            do while (.not. done)
               if (is_ident (ident, line, lp)) then
                  argcount = argcount + 1
                  nametable(ntp:) = ident(1:)
                  nameptr(argcount) = ntp
                  ntp = ntp + index (ident, NULL)
               else if (line(lp:lp) .eq. ')') then
                  done = .true.
               else if (line(lp:lp) .eq. ',') then
                  lp = lp + 1
               else if (line(lp:lp) .eq. NEWLINE) then
                  call pperror 
     &            ('missing right parenthesis in argument list'//NULL, line)
                  done = .true.
               else if (line(lp:lp) .eq. '(') then
                  call pperror 
     &            ('illegal parentheses in argument list'//NULL, line)
                  done = .true.
               else               !all other characters are illegal
                  call pperror 
     &            ('argument must be an identifier'//NULL, line)
                  done = .true.
               end if
            end do
            if (line(lp:lp) .eq. ')') then
               lp = lp + 1
            else
               call pperror ('statement ignored'//NULL, line)
               return
            end if
         else                               !no arguments
            continue
         end if
      else                                  !no identifier after #DEFINE
         call pperror 
     &   ('object of DEFINE must be an identifier'//NULL, line)
         return
      end if

! get definition
      do while (line(lp:lp) .eq. BLANK)      !skip leading blanks
         lp = lp + 1
      end do
      if (line(lp:lp) .ne. NEWLINE) then
         i = lp
         endp = lp
         do while (line(i:i) .ne. NEWLINE)   !find last nonblank
            if (line(i:i) .ne. BLANK) endp = i
            i = i + 1
         end do
         line(endp+1:endp+2) = EOL           !effectively deletes 
      end if                                 !trailing blanks

! scan the definition and encode arguments
      done = .false.
      defp = 1
      do while (.not. done)
         if (line(lp:lp) .eq. NEWLINE) then
            done = .true.
         else if (line(lp:lp) .eq. BLANK) then !save blanks from is_ident
            def(defp:defp) = BLANK
            defp = defp + 1
            lp = lp + 1
         else if (is_ident (ident, line, lp)) then  !lookup name
            found = .false.
            argno = 1
            do while ((.not. found) .and. (argno .le. argcount))
               if (equal (ident, nametable(nameptr(argno):))) then
                  found = .true.
               else
                  argno = argno + 1
               end if
            end do
            if (found) then                 !substitute arg flag for ident
               def(defp:defp) = ARGFLAG
               def(defp+1:defp+1) = char(argno + ichar('0'))
               defp = defp + 2
            else
               i = 1
               do while (ident(i:i) .ne. NULL)
                  def(defp:defp) = ident(i:i)
                  defp = defp + 1
                  i = i + 1
               end do
            end if
         else if (line(lp:lp) .eq. ESCAPE) then !special character
            c = escchar (line, lp)
            if (c .eq. ARGFLAG) then
               def(defp:defp+1) = ARGFLAG//'0'
               defp = defp + 2
            else
               def(defp:defp) = c
               defp = defp + 1
            end if
         else                                   !ordinary character
            if (line(lp:lp) .eq. ARGFLAG) then
               def(defp:defp+1) = ARGFLAG//'0'
               defp = defp + 2
            else
               def(defp:defp) = line(lp:lp)
               defp = defp + 1
            end if
            lp = lp + 1
         end if
      end do
      def(defp:defp) = NULL

      if (.not. mkdef (name, def, argcount)) then
         call pperror ('symbol table overflow'//NULL, line)
      end if

      return
      end
