! eps_closure  -  find set of states that can be reached on empty string

      subroutine eps_closure (clset, s, epsset, epstab)
      integer   clset (*)     !return array containing eps_closure(s)
      integer   s             !input state
      integer   epsset (*)    !ptrs to epsilon transition lists for states
      integer   epstab (*)    !list table
      include   'global.def'
      integer   MAXSTACK
      parameter (MAXSTACK = 256)
      integer   stack (MAXSTACK), sp
      integer   i, j, k
      logical   found

! add all epsilon transitions of s to clset
      clset(1) = s          !eps_closure(s) always includes s
      j = 2                 !pointer to next element of clset
      sp = 0
      i = epsset(s)
      do while (epstab(i) .ne. ENDLIST)
         sp = sp + 1
         stack(sp) = epstab(i)
         clset(j) = epstab(i)
         i = i + 1
         j = j + 1
      end do

! add epsilon transitions from states in clset to clset
      do while (sp .gt. 0)
         i = epsset(stack(sp))
         sp = sp - 1
         do while (epstab(i) .ne. ENDLIST)
            found = .false.          !see if state is already in closure
            k = 1
            do while (.not. found .and. k .lt. j)
               if (clset(k) .eq. epstab(i)) found = .true.
               k = k + 1
            end do
            if (.not. found) then    !add it and its epsset to closure
               sp = sp + 1
               stack(sp) = epstab(i)
               clset(j) = epstab(i)
               j = j + 1
            end if
            i = i + 1
         end do
      end do

      clset(j) = ENDLIST
      return
      end
