! f77name  -  truncate long identifiers to 6 characters

      subroutine f77name (line)
      character*(*)       line
      include             'global.def'
      include             'forttable.cmn'
      integer             KEYWORD, SHORT, LONG
      parameter           (KEYWORD = 1)
      parameter           (SHORT = 2)
      parameter           (LONG = 3)
      integer             i, lp, op, p, shortp, idlen, hlookup
      logical             is_ident, inquote
      character*(MAXSTR)  id, shortid
      integer             hash3
      external            hash3, f77data

      lp = 1
      op = 1
      do while (line(lp:lp) .ne. NEWLINE)
         do while (line(lp:lp) .eq. BLANK)
            line(op:op) = BLANK
            lp = lp + 1
            op = op + 1
         end do
         if (line(lp:lp) .eq. NEWLINE) then
            continue
         else if (is_ident (id, line, lp)) then
            idlen  = index (id, NULL) - 1
            if (idlen .gt. 6) then
               do i = 1, 6            !replace dollar and underscore
                  if (id(i:i) .eq. '_' .or. id(i:i) .eq. '$') then
                     shortid(i:i) = 'X'
                  else
                     shortid(i:i) = id(i:i)
                  end if
               end do
               shortid(7:7) = NULL
               p = hlookup (id,buffer,namep,nextp,htable,hash3,hashsize)
               if (p .eq. 0) then     !not found - install in table
                  call hinstall (id,buffer,bufp,namep,nextp,tabp,
     &                           htable,hash3,hashsize)
                  type(tabp) = LONG
                  tabp = tabp + 1
                  bufp = bufp + idlen + 1
                  shortp = hlookup (shortid,buffer,namep,nextp,
     &                              htable,hash3,hashsize)
                  if (shortp .eq. 0) then
                     call hinstall (shortid,buffer,bufp,namep,nextp,tabp,
     &                              htable,hash3,hashsize)
                     type(tabp) = SHORT
                     tabp = tabp + 1
                     bufp = bufp + 7
                  else
                     call fputstr (STDERR, 'f77name: name conflict:'//EOL)
                     call fputstr (STDERR, buffer(namep(tabp-1):))
                     call fputstr (STDERR, '  '//buffer(namep(shortp):))
                     call fputc (STDERR, NEWLINE)
                  end if
                  line(op:op+5) = shortid(1:6)
                  op = op + 6
               else if (type(p) .eq. KEYWORD) then   !leave it alone
                  line(op:op+idlen-1) = id(1:idlen)
                  op = op + idlen
               else             !found and not keyword - use short name
                  line(op:op+5) = shortid(1:6)
                  op = op + 6
               end if
            else if (idlen .eq. 6) then             !check for conflicts
               p = hlookup (id,buffer,namep,nextp,htable,hash3,hashsize)
               if (p .eq. 0) then
                  call hinstall (id,buffer,bufp,namep,nextp,tabp,
     &                           htable,hash3,hashsize)
                  type(tabp) = LONG
                  tabp = tabp + 1
                  bufp = bufp + idlen + 1
               else if (type(p) .eq. SHORT) then
                     call fputstr (STDERR, 'f77name: name conflict:'//EOL)
                     call fputstr (STDERR, buffer(namep(p):))
                     call fputstr (STDERR, 
     &               ' conflicts with previously shortened name'//EOL)
               end if
               line(op:op+5) = id(1:6)
               op = op + 6
            else              !name shorter than 6 chars - use as is
               line(op:op+idlen-1) = id(1:idlen)
               op = op + idlen
            end if
         else if (line(lp:lp) .eq. QUOTE) then   !skip quotes
            line(op:op) = QUOTE
            lp = lp + 1
            op = op + 1
            do while (line(lp:lp) .ne. QUOTE .and. line(lp:lp) .ne. NEWLINE) 
               line(op:op) = line(lp:lp)
               op = op + 1
               lp = lp + 1
            end do
            line(op:op) = QUOTE
            op = op + 1
            if (line(lp:lp) .eq. NEWLINE) then
               call fputstr (STDERR, 'f77name: missing quote'//EOL)
            else
               lp = lp + 1
            end if
         else
            line(op:op) = line(lp:lp)
            lp = lp + 1
            op = op + 1
         end if
      end do
      line(op:op+1) = EOL

      return
      end
