! getline  -  get input line from terminal (with recall)

      logical function getline (line)
      character*(*)        line
      include              'global.def'
      include              'keyboard.def'
      include              'ansi.def'
      include              'ttio.cmn'
      integer              MAXRECALL
      parameter            (MAXRECALL = 20)
      integer              MAXCMD
      parameter            (MAXCMD = 79)
      character*1          CTRLX
      parameter            (CTRLX = char(21))
      integer              rbp, nbp, ebp, ebl, i, j
      character*1          getc, c
      character*(MAXSTR)   itoa, cb
      character*(MAXCMD+1) rbuf(MAXRECALL), ebuf
      save  rbuf, nbp
      data  nbp  /0/

      nbp = mod (nbp, MAXRECALL) + 1
      rbp = nbp
      ebp = 1
      ebl = 0
      rbuf(nbp)(1:1) = NULL
      ebuf(1:1) = NULL

      call putstr (CR//LINEFEED//prompt)

      do while (getc(c) .ne. NEWLINE)
         if (c .eq. EOF) then
            getline = .false.
            line(1:2) = EOF//NULL
            return
         else if (c .eq. K$UP) then
            rbp = rbp - 1                    !previous line
            if (rbp .lt. 1) rbp = MAXRECALL  !wrap to bottom
            ebuf = rbuf(rbp)                 !fill edit buffer
            ebp  = index (ebuf, NULL)        !cursor at end of line
            ebl  = ebp - 1
            call putstr (CLRLINE)            !refresh screen
            call putstr (CR//prompt)
            call putstr (ebuf)
         else if (c .eq. K$DOWN) then
            rbp = rbp + 1                    !next line
            if (rbp .gt. MAXRECALL) rbp = 1  !wrap to top
            ebuf = rbuf(rbp)                 !fill edit buffer
            ebp  = index (ebuf, NULL)        !cursor at end of line
            ebl  = ebp - 1
            call putstr (CLRLINE)            !refresh screen
            call putstr (CR//prompt)
            call putstr (ebuf)
         else if (c .eq. K$LEFT) then
            if (ebp .gt. 1) then 
               ebp = ebp - 1
               call putstr (CRSLEFT)
            end if
         else if (c .eq. K$RIGHT) then
            if (ebp .le. ebl) then
               ebp = ebp + 1
               call putstr (CRSRIGHT)
            end if
         else if (c .eq. K$DEL) then
            if (ebp .gt. 1) then
               ebuf(ebp-1:) = ebuf(ebp:)     !delete character
               ebp = ebp - 1                 !update pointers
               ebl = ebl - 1
               cb  = itoa (ebl-ebp+1)        !build escape sequence
               call putstr (CRSLEFT)         !refresh screen
               call putstr (CLREND)
               call putstr (ebuf(ebp:))
               if (ebl-ebp+1 .ne. 0) 
     &           call putstr (ESC//'['//cb(1:index(cb,NULL)-1)//'D'//NULL)
            end if
         else if (c .eq. CTRLX) then         !clear line
            ebl = 0
            ebp = 1
            ebuf(1:1) = NULL
            call putstr (CLRLINE)
            call putstr (CR//prompt)
         else                                !insert character
            if (ebl .eq. 0) then
               ebuf = c//NULL
               ebl = 1
               ebp = 2
            else if (ebl .ge. MAXCMD) then
               if (ebp .eq. 1) then
                  ebuf = c//ebuf(1:MAXCMD-1)//NULL
                  ebp = ebp + 1
               else if (ebp .ge. MAXCMD) then
                  ebuf(MAXCMD:MAXCMD) = c
               else
                  ebuf = ebuf(1:ebp-1)//c//ebuf(ebp:MAXCMD-1)//NULL
                  ebp = ebp + 1
               end if
            else
               if (ebp .eq. 1) then
                  ebuf = c//ebuf(1:ebl)//NULL
               else
                  ebuf = ebuf(1:ebp-1)//c//ebuf(ebp:)
               end if
               ebp = ebp + 1
               ebl = ebl + 1
            end if
            call putstr (INSCHAR)
            call putc   (c)
         end if
      end do
      call putstr (CR//NULL)

      rbuf(nbp) = ebuf                 !copy edit buffer to recall buffer
      if (ebl .eq. 0) then
         line = EOL
      else
         line = ebuf(1:ebl)//EOL
      end if

      getline = .true.

      return
      end
