! getlogline  -  get logical line of input

      logical function getlogline (logline)
      character*(*)      logline
      include            'global.def'
      character*(MAXSTR) line
      logical            ppline, done, gotline
      integer            s, lp, llp, tp, i
      character*1        c
      data gotline / .false. /
      save gotline, lp, line

      if (.not. gotline) then
         done = .false.
         do while (.not. done)                !get first line
            if (ppline(line)) then
               lp = 1
               do while (line(lp:lp) .eq. BLANK .or. line(lp:lp) .eq. ';')
                  if (line(lp:lp) .eq. ';') line(lp:lp) = BLANK
                  lp = lp + 1
               end do
               if (line(lp:lp) .ne. NEWLINE .and. 
     &             line(lp:lp) .ne. COMMENT) then
                  done = .true.
               end if
            else
               getlogline = .false.
               return
            end if
         end do
         lp = 0
      end if

      done = .false.
      llp = 1
      s = 1
      do while (.not. done)
         lp = lp + 1
         c = line(lp:lp)
         if (s .eq. 1) then        !initial state
            if (c .eq. NEWLINE .or. c .eq. COMMENT) then
               logline(llp:llp+1) = EOL
               getlogline = .true.
               gotline = .false.
               done = .true.
            else if (c .eq. ';') then
               logline(llp:llp+1) = EOL
               getlogline = .true.
               i = lp + 1
               do while (line(i:i) .eq. BLANK .or. line(i:i) .eq. ';')
                  if (line(i:i) .eq. ';') line(i:i) = BLANK
                  i = i + 1
               end do
               if (line(i:i) .eq. NEWLINE .or. line(i:i) .eq. COMMENT) then
                  gotline = .false.
               else
                  gotline = .true.
               end if
               done = .true.
            else if (c .eq. '&') then
               tp = lp
               s = 2
            else if (c .eq. QUOTE) then
               logline(llp:llp) = QUOTE
               llp = llp + 1
               s = 3
            else if (c .eq. ' ') then       !crunch blanks
               if (lp .eq. 1) then
                  continue
               else if (line(lp-1:lp-1) .eq. ' ') then
                  continue
               else if (line(lp-1:lp-1) .eq. ';') then
                  continue
               else
                  logline(llp:llp) = ' '
                  llp = llp + 1
               end if
            else
               logline(llp:llp) = c
               llp = llp + 1
            end if
         else if (s .eq. 2) then   !seen & outside of character context
            do while (line(lp:lp) .eq. ' ')
               lp = lp + 1
            end do
            if (line(lp:lp) .eq. NEWLINE .or. line(lp:lp) .eq. COMMENT) then
               if (ppline(line)) then
                  lp = 0
               else
                  call fputstr (STDERR, 
     &            'unexpected EOF after continuation'//EOL)
                  getlogline = .false.
                  done = .true.
               end if
            else
               lp = tp
               logline(llp:llp) = '&'
               llp = llp + 1
            end if
            s = 1
         else if (s .eq. 3) then   !in character context
            if (c .eq. QUOTE) then
               logline(llp:llp) = QUOTE
               llp = llp + 1
               s = 1
            else if (c .eq. '&') then
               tp = lp
               s = 4
            else
               logline(llp:llp) = c
               llp = llp + 1
            end if
         else if (s .eq. 4) then   !seen & within character context
            do while (line(lp:lp) .eq. ' ')
               lp = lp + 1
            end do
            if (line(lp:lp) .eq. NEWLINE) then
               if (ppline(line)) then
                  lp = 0
                  s = 5
               else
                  call fputstr (STDERR, 
     &            'unexpected EOF in character context'//EOL)
                  getlogline = .false.
                  done = .true.
               end if
            else
               logline(llp:llp+(lp-tp)) = line(tp:lp)
               llp = llp + lp - tp
               if (line(lp:lp) .eq. QUOTE) then
                  s = 1
               else
                  s = 3
               end if
            end if
         else if (s .eq. 5) then   !new line in continued character context
            do while (line(lp:lp) .eq. ' ')
               lp = lp + 1
            end do
            if (line(lp:lp) .eq. '&') then
               s = 3
            else 
               logline(llp:llp+lp) = line(1:lp)
               llp = llp + lp
               if (line(lp:lp) .eq. QUOTE) then
                  s = 1
               else
                  s = 3
               end if
            end if
         else
            call fputstr (STDERR, 'cannot happen in GETLOGLINE'//EOL)
         end if
      end do

      return
      end
