! hashgen  -  hash table generator

      program hashgen
      include             'global.def'
      include             'hashgen.cmn'
      integer             argc, uin, uout
      logical             finclude, equal, is_ident, upflag
      logical             is_ival, errflag
      integer             lp, i, j
      character*(MAXSTR)  argv(MAXARGS), upper
      character*(MAXSTR)  line, ident, type

      call ioinit ()
      call getargs (argc, argv)
      call stdargs (argc, argv, uin, uout)
      upflag = .false.
      name(1:1) = NULL
      do i = 1, argc
         if (argv(i)(1:1) .eq. QUALIFIER) then
            argv(i) = upper (argv(i))
            j = index(argv(i),NULL)
            if (index(argv(i)(1:j),'U') .gt. 0) upflag = .true.
         else                       !define prefix for output file names
            if (name(1:1) .eq. NULL) then 
               j = index(argv(i)(1:index(argv(i),NULL)), '.')
               if (j .eq. 0) then
                  name = argv(i)
               else
                  name = argv(i)(1:j-1)//NULL
               end if
            end if
         end if
      end do
      if (uin .eq. IOERROR .or. uout .eq. IOERROR) stop 'hashgen aborted'

      call inclinit (uin)
      call hashinit ()       !provide defaults and initialize table 
      errflag = .false.
      do while (finclude (line))
         lp = 1
         if (is_ident (ident, line, lp)) then
            ident = upper (ident)
            do while (line(lp:lp).eq.' ' .or. line(lp:lp).eq.'=')
               lp = lp + 1
            end do
            if (equal (ident, 'HASHFUNCTION'//NULL)) then
               if (.not. is_ival (hashfunction, line, lp)) then
                  call fputstr (STDERR, 'integer value required'//EOL)
                  call fputstr (STDERR, line)
                  errflag = .true.
               end if
            else if (equal (ident, 'HASHSIZE'//NULL)) then
               if (.not. is_ival (hashsize, line, lp)) then
                  call fputstr (STDERR, 'integer value required'//EOL)
                  call fputstr (STDERR, line)
                  errflag = .true.
               end if
            else if (equal (ident, 'MAXSYMBOL'//NULL)) then
               if (.not. is_ival (maxsymbol, line, lp)) then
                  call fputstr (STDERR, 'integer value required'//EOL)
                  call fputstr (STDERR, line)
                  errflag = .true.
               end if
            else if (equal (ident, 'MAXBUFFER'//NULL)) then
               if (.not. is_ival (maxbuffer, line, lp)) then
                  call fputstr (STDERR, 'integer value required'//EOL)
                  call fputstr (STDERR, line)
                  errflag = .true.
               end if
            else if (equal (ident, 'ARRAY'//NULL)) then
               acount = acount + 1
               if (is_ident (type, line, lp)) then
                  type = upper (type)
                  atype(acount) = BOGUSTYPE
                  if (equal (type, 'INTEGER'//NULL)) atype(acount) = ITYPE
                  if (equal (type, 'REAL'//NULL)) atype(acount) = RTYPE
                  if (equal (type, 'LOGICAL'//NULL)) atype(acount) = LTYPE
                  if (equal (type, 'STRING'//NULL)) atype(acount) = STYPE
                  if (atype(acount) .eq. BOGUSTYPE) then
                     call fputstr (STDERR, 'invalid ARRAY type: '//EOL)
                     call fputstr (STDERR, line)
                     errflag = .true.
                  end if
                  if (.not. is_ident (aname(acount), line, lp)) then
                     call fputstr (STDERR, 'invalid ARRAY name'//EOL)
                     call fputstr (STDERR, line)
                     errflag = .true.
                  end if
               else
                  call fputstr (STDERR, 'invalid ARRAY statement'//EOL)
                  call fputstr (STDERR, line)
                  errflag = .true.
               end if
            else                             !data input
               if (upflag) ident = upper (ident)
               if (.not. errflag) call hashident (ident, line, lp)
            end if
         else
            if (line(lp:lp).ne.NEWLINE .and. line(lp:lp).ne.COMMENT) then
               call fputstr (STDERR, 'hashgen: unrecognized keyword:'//EOL)
               call fputstr (STDERR, line)
               errflag = .true.
            end if
         end if
      end do

      call hashrpt  (uout)  !write collision report
      call hashcmn  ()      !write common block file
      call hashdata ()      !write block data file

      end
