! macscan  -  scan line for macro calls and expand

      subroutine macscan (line, quotec)
      character*(*)      line
      character*1        quotec
      include            'global.def'
      include            'macscan.cmn'
      include            'pperror.cmn'
      character*1        c, getpbc, getpbtoken
      integer            optr, i, argcount
      logical            pb_ident, isletter, finddef
      character*(MAXSTR) ident, def

      call pbstr (line)
      optr = 1
      fp = 0
      sp = 1
      bp = 1

      do while (getpbtoken(ident) .ne. NULL)
         c = ident(1:1)

         if (isletter(c) .or. c .eq. '$' .or. c .eq. '_') then
            !check for macro
            if (finddef (ident, def, argcount)) then !make new stack frame
               call mkframe (def)
               if (argcount .eq. 0) then  !no args - expand immediately
                  call expand ()
                  sp = fp - 1             !pop stack frame
                  fp = stack (fp)
                  bp = stack(sp)
               end if
            else                          !finddef failed - not a macro
               i = 1
               do while (ident(i:i) .ne. NULL)
                  call putchr (ident(i:i), line, optr)
                  i = i + 1
               end do
            end if

         else if (c .eq. quotec) then         !skip quote
            do while ((getpbc(c) .ne. quotec) .and. (c .ne. NULL))
               call putchr (c, line, optr)
            end do
            if (c .eq. NULL) then
               call pperror ('missing quote'//NULL, line)
            end if

         else if (fp .eq. 0) then             !not in any macro
            call putchr (c, line, optr)

         else if (c .eq. '(') then
            if (stack(fp+PLEVEL) .gt. 0) then !part of argument - keep it
               call putchr (c, line, optr)
            end if
            stack(fp+PLEVEL) = stack(fp+PLEVEL) + 1

         else if (c .eq. ')') then
            stack(fp+PLEVEL) = stack(fp+PLEVEL) - 1
            if (stack(fp+PLEVEL) .gt. 0) then !part of argument - keep it
               call putchr (c, line, optr)
            else                              !end of argument list
               call putchr (NULL, line, optr)
               call expand ()    !expand macro and put back onto input
               sp = fp - 1       !pop stack frame
               fp = stack(fp)
               bp = stack(sp)
            end if

         else if ((c .eq. ',') .and. 
     &            (stack(fp+PLEVEL) .eq. 1)) then  !new argument
            call putchr (NULL, line, optr)
            if (sp .gt. STACKSIZE) then
               call pperror ('stack overflow'//NULL, line)
            else
               stack(sp) = bp
               sp = sp + 1
            end if

         else                                   !everything else
            call putchr (c, line, optr)

         end if
      end do

      if (fp .gt. 0) then
         call pperror ('line ended during expansion of macro'//NULL, line)
      end if
! empty putback buffer in case of error
      do while (getpbc(c) .ne. NULL)
         continue
      end do
      line(optr:optr) = NULL

      return
      end
