! mkdfa  -  construct dfa from nfa

      subroutine mkdfa ()
      include  'global.def'
      include  'nfa.cmn'
      include  'dfa.cmn'
      integer  M                 !DFA state currently being considered
      integer  P (16)            !set of states reachable from {M} on i
      integer  N (128)           !eps_closure({P}) = dfanext(i,M)
      integer  subset (MAXDFA)   !set of NFA states in each DFA state
      integer  subtab (8*MAXDFA) !storage table for subset lists
      integer  subp              !pointer to next available entry in subtab
      integer  stack (64)        !list of DFA states to be considered
      integer  sp
      integer  i, j, k, smin
      logical  found, eqvset

! initialize DFA tables
      do i = 1, MAXDFA
         do j = 0, MAXCHAR
            dfanext(j,i) = 0
         end do
         dfatoken(i) = 0
      end do

! compute subset of first NFA state and store it as first DFA subset
      call eps_closure (N, 1, epsset, epstab)
      subp = 1
      subset(1) = subp
      call ascopy (N, subp, subtab)

      d = 1
      sp = 1
      stack(1) = 1
      do while (sp .gt. 0)
         M = stack(sp)
         sp = sp - 1
         do i = 0, MAXCHAR
            j = subset(M)
            k = 1
            do while (subtab(j) .ne. ENDLIST)  !see if transition exists
               if (chrset(subtab(j)) .eq. LITCHAR) then
                  found = (cval1(subtab(j)) .eq. i)
               else if (chrset(subtab(j)) .eq. RANGE) then
                  found = (i .ge. cval1(subtab(j)) .and. 
     &                     i .le. cval2(subtab(j)))
               else
                  found = .false.
               end if
               if (found) then                 !add to {P}
                  P(k) = subtab(j) + 1         !next state always s + 1
                  k = k + 1
               end if
               j = j + 1
            end do
            P(k) = ENDLIST
            if (k .eq. 1) then                !{P} is empty
               continue
            else
               !compute eps_closure of {P}
               call eps_union (N, P, epsset, epstab)
               ! see if {N} is already a state of the DFA
               call bubblesort (N)   !sort N before comparing
               j = 0
               found = .false.
               do while (.not. found .and. j .lt. d)
                  j = j + 1
                  found = eqvset (N, subset(j), subtab)
               end do
               if (found) then  !add a transition to existing state
                  dfanext(i,M) = j
               else             !create state and add transition
                  d = d + 1
                  sp = sp + 1
                  stack(sp) = d
                  !store subset for new state
                  subset(d) = subp
                  call ascopy (N, subp, subtab) 
                  dfanext(i,M) = d
               end if
            end if
         end do            !over all input characters
      end do               !until all dfa states have been constructed

! set token values -
! if two or more NFA states in subset have token values, the token value 
! of the smallest NFA state number is accepted

      do i = 1, d
         j = subset(i)
         smin = MAXNFA
         k = 0
         ! find min nfa state # with non-zero token value
         do while (subtab(j) .ne. ENDLIST)
            if (nfatoken(subtab(j)) .ne. 0) then
               if (subtab(j) .lt. smin) then
                  k = nfatoken (subtab(j))
                  smin = subtab(j)
               end if
            end if
            j = j + 1
         end do
         dfatoken(i) = k
      end do

      return
      end
