! mkdflt  -  choose default states for DFA states

      subroutine mkdflt ()
      include   'global.def'
      include   'dfa.cmn'
      include   'lexscan.cmn'
      integer   MINTRANS         !min # transitions to consider defaults
      parameter (MINTRANS = 4)
      logical   used (MAXDFA)    !true if state has been used as a default
      logical   changed (MAXDFA) !true if state has been defaulted
      integer   i, j, k, trcount
      integer   ilist(MAXCHAR+1), ii, jlist(MAXCHAR+1), jj
      logical   same(0:MAXCHAR), sameset, closure, is_element

! initialize
      do i = 1, d
         default(i) = 0
         used(i) = .false.
         changed(i) = .false.
      end do

      do i = 1, d                !state under consideration
         closure = .true.
         trcount = 0
         do k = 0, MAXCHAR
            if (dfanext(k,i) .ne. 0) then
               trcount = trcount + 1
               if (dfanext(k,i) .ne. i) closure = .false.
            end if
         end do
         if (closure .or. trcount .le. MINTRANS) then
            used(i) = .true.
            goto 1  !cycle to next i
         end if
         do j = 1, d             !compare i with all other states
            if ((i.ne.j) .and. (.not.used(i)) .and. (.not.changed(j))) then
               sameset = .true.  !true only if set of characters with nonzero
                                 !transitions is the same for states i and j
               k = 0
               do while (k .le. MAXCHAR .and. sameset)
                  same(k) = ((dfanext(k,i).eq.0 .and. dfanext(k,j).eq.0) .or.
     &                       (dfanext(k,i).ne.0 .and. dfanext(k,j).ne.0))
                  if (.not. same(k)) sameset = .false.
                  k = k + 1
               end do
               if (sameset) then
                  ii = 1
                  jj = 1
                  do k = 0, MAXCHAR
                     same(k) = (dfanext(k,i) .eq. dfanext(k,j))
                     !count # of states reachable from states i and j
                     if (.not. is_element(dfanext(k,i), ilist, 1)) then
                        ilist(ii) = dfanext(k,i)
                        ii = ii + 1
                     end if
                     if (.not. is_element(dfanext(k,j), jlist, 1)) then
                        jlist(jj) = dfanext(k,j)
                        jj = jj + 1
                     end if
                  end do
                  ilist(ii) = ENDLIST
                  jlist(jj) = ENDLIST
                  if (ii .ge. jj) then  !make j the default state for i
                     default(i) = j
                     changed(i) = .true.
                     used(j) = .true.
                     do k = 0, MAXCHAR      !remove all defaulted transitions
                        if (same(k)) dfanext(k,i) = 0
                     end do
                     goto 1             !done with state i
                  !else i is a suitable default for j
                  end if
               !else transitions not on same character set
               end if
            !else i = j
            end if
         end do                      !j
    1    continue
      end do

      return
      end
