! mklex  -  make compressed lex table from DFA matrix form

      subroutine mklex (nstates, nentries)
      integer            nstates, nentries  !return values
      include            'global.def'
      include            'dfa.cmn'
      include            'lexscan.cmn'
      integer            freep, p, s, i, offset
      logical            conflict, done
      character*(MAXSTR) itoa

! initialize tables
      do i = 1, MAXSTATE
         base(i) = 0
         tokval(i) = 0
      end do
      do i = 0, MAXENTRY
         next(i) = 0
         check(i) = 0
      end do

! set token values
      do i = 1, d
         tokval(i) = dfatoken(i)
      end do

! set up initial state
      base(1) = 0
      default(1) = 0
      do i = 0, MAXCHAR
         next(i) = dfanext (i, 1)
         if (dfanext(i, 1) .eq. 0) then
            check(i) = 0
         else
            check(i) = 1
         end if
      end do

      freep = MAXCHAR + 1
      do s = 2, d
         do while (check(freep) .ne. 0)
            freep = freep + 1
         end do
         p = freep     !candidate position for 1st used character in s
         done = .false.
         do while (.not. done)        !find 1st available base address
            offset = 0
            do while (dfanext(offset, s) .eq. 0 .and. !find 1st transition
     &                offset .le. MAXCHAR)            !from this state
               offset = offset + 1
            end do
            base(s) = p - offset
            conflict = .false.
            do i = offset, MAXCHAR
               if (dfanext(i,s) .ne. 0) then
                  if (check(base(s)+i) .ne. 0) conflict = .true.
               end if
            end do
            if (conflict) then     !advance to next candidate position
               p = p + 1
               do while (check(p) .ne. 0)
                  p = p + 1
               end do
            else
               done = .true.
            end if
         end do
         do i = offset, MAXCHAR     !install transitions in next/check
            if (dfanext(i,s) .ne. 0) then
               next(base(s)+i) = dfanext(i,s)
               check(base(s)+i) = s
            end if
         end do
      end do

      nstates = d
      nentries = base(d) + MAXCHAR
      call fputstr (STDOUT, 'lexscan table size = '//itoa(nentries))
      call fputc (STDOUT, NEWLINE)
      i = 0
      do s = 1, nentries
         if (check(s) .eq. 0) i = i + 1
      end do
      call fputstr (STDOUT, 'lexscan unused entries = '//itoa(i))
      call fputc (STDOUT, NEWLINE)

      return
      end
