! mknfa  -  make an NFA from regular expression

      subroutine mknfa (s, line, lp)
      character*(*) line
      integer       lp, s
      include       'global.def'
      include       'nfa.cmn'
      integer       MAXEMPTY
      parameter     (MAXEMPTY = 20)
      integer       tmpset1 (MAXEMPTY), tmpset2 (MAXEMPTY)
      integer       i
      logical       done
      character*1   c, escchar, nextc

      integer       MAXSTACK
      parameter     (MAXSTACK = 32)
      integer       type (MAXSTACK)       !stack entry type
      integer       startstate (MAXSTACK) !start end end states for 
      integer       endstate (MAXSTACK)   !generation of epsset entries
      integer       sp

! stack entry types
      integer       CLOSURE, ALT, OR
      parameter     (CLOSURE = 1)
      parameter     (ALT = 2)
      parameter     (OR = 3)

      sp = 0
      do while (nextc (c, line, lp) .ne. NEWLINE .and. c .ne. COMMENT)
         if (c .eq. ESCAPE) then                      !literal escaped char
            chrset(s) = LITCHAR
            lp = lp - 1                               !point to ESCAPE
            cval1(s) = ichar(escchar(line, lp))
            tmpset1(1) = ENDLIST
            epsset(s) = epstabp
            call ascopy (tmpset1, epstabp, epstab)
            s = s + 1
         else if (c .eq. '[') then                !range
            chrset(s) = RANGE
            if (nextc(c, line, lp) .eq. ESCAPE) then
               lp = lp - 1
               cval1(s) = ichar(escchar(line, lp))
            else
               cval1(s) = ichar(c)
            end if
            if (nextc(c, line, lp) .ne. '-') then
               call fputstr (STDERR, 'invalid range syntax'//EOL)
               call fputstr (STDERR, line)
            end if
            if (nextc(c, line, lp) .eq. ESCAPE) then
               lp = lp - 1
               cval2(s) = ichar(escchar(line, lp))
            else
               cval2(s) = ichar(c)
            end if
            tmpset1(1) = ENDLIST
            epsset(s) = epstabp
            call ascopy (tmpset1, epstabp, epstab)
            s = s + 1
            if (nextc(c, line, lp) .ne. ']') then
               call fputstr (STDERR, 'invalid range syntax'//EOL)
               call fputstr (STDERR, line)
            end if
         else if (c .eq. '{') then                  !begin closure
            sp = sp + 1
            type(sp) = CLOSURE
            startstate(sp) = s
            s = s + 1
         else if (c .eq. '}') then                  !end closure
            if (type(sp) .ne. CLOSURE) then
               call fputstr (STDERR, 'closure delimiter mismatch'//EOL)
               call fputstr (STDERR, line)
            else
               tmpset1(1) = startstate(sp) + 1
               tmpset1(2) = s + 1
               tmpset1(3) = ENDLIST
               epsset(s) = epstabp
               call ascopy (tmpset1, epstabp, epstab)
               chrset(s) = NONE
               tmpset1(1) = s + 1
               tmpset1(2) = startstate(sp) + 1
               tmpset1(3) = ENDLIST
               epsset(startstate(sp)) = epstabp
               call ascopy (tmpset1, epstabp, epstab)
               chrset(startstate(sp)) = NONE
               sp = sp - 1
               s = s + 1
            end if
         else if (c .eq. '(') then                  !begin alternative
            sp = sp + 1
            type(sp) = ALT
            startstate(sp) = s
            sp = sp + 1
            type(sp) = OR
            startstate(sp) = s + 1
            s = s + 1
         else if (c .eq. '|') then                    !delimit alternative
            endstate(sp) = s
            sp = sp + 1
            type(sp) = OR
            startstate(sp) = s + 1
            s = s + 1
         else if (c .eq. ')') then                  !end alternative
            endstate(sp) = s
            s = s + 1
            i = 1
            done = .false.
            do while (.not. done)
               if (type(sp) .eq. OR) then
                  tmpset1(i) = startstate(sp)
                  tmpset2(1) = s
                  tmpset2(2) = ENDLIST
                  epsset(endstate(sp)) = epstabp
                  call ascopy (tmpset2, epstabp, epstab)
                  chrset(endstate(sp)) = NONE
                  sp = sp - 1
                  i = i + 1
               else if (type(sp) .eq. ALT) then
                  done = .true.
                  tmpset1(i) = ENDLIST
                  epsset(startstate(sp)) = epstabp
                  call ascopy (tmpset1, epstabp, epstab)
                  chrset(startstate(sp)) = NONE
                  sp = sp - 1
               else
                  call fputstr (STDERR, 'or delimiter mismatch'//EOL)
                  call fputstr (STDERR, line)
               end if
            end do
         else                                        !literal character
            chrset(s) = LITCHAR
            cval1(s) = ichar(c)
            tmpset1(1) = ENDLIST
            epsset(s) = epstabp
            call ascopy (tmpset1, epstabp, epstab)
            s = s + 1
         end if
      end do

! give final state an epsset
      epsset(s) = epstabp
      call ascopy (ENDLIST, epstabp, epstab)

      return
      end
