! operator  -  generate code for arithmetic expression operators

      subroutine operator (t, c)
      integer      t, c
      #include     global.def
      #include     spl.mac
      #include     vm.mac
      #include     parse.cmn

      if (c .eq. UNARY_SIGN) then
         if (type(esp) .eq. REALTYPE .or. type(esp) .eq. INTTYPE) then
            if (aorv(esp) .eq. ADDRESS) then
               call emit1 (_val)
               aorv(esp) = VALUE
            end if
         else
            call perror ('type mismatch'//NULL)
         end if
         if (t .eq. $sub) then
            if (type(esp) .eq. INTTYPE) call emit1 (_neg_i)
            if (type(esp) .eq. REALTYPE) call emit1 (_neg_r)
         end if
      else if 
     & (c .eq. BINARY_ARITHMETIC_OP .or. c .eq. BINARY_RELATIONAL_OP) then
         if (aorv(esp) .eq. ADDRESS) then
            call emit1 (_val)
            aorv(esp) = VALUE
         end if
         if (aorv(esp-1) .eq. ADDRESS) then
            call emit1 (_val2)
            aorv(esp-1) = VALUE
         end if
         if (type(esp) .eq. REALTYPE .or. type(esp-1) .eq. REALTYPE) then
            if (type(esp) .eq. INTTYPE) call emit1 (_flt)
            if (type(esp-1) .eq. INTTYPE) call emit1 (_flt2)
            if (type(esp) .eq. LOGTYPE .or. type(esp-1) .eq. LOGTYPE) then
               call perror ('type conversion error'//NULL)
            end if
            if (t .eq. $add)  call emit1 (_add_r)
            if (t .eq. $sub)  call emit1 (_sub_r)
            if (t .eq. $mult) call emit1 (_mult_r)
            if (t .eq. $div)  call emit1 (_div_r)
            if (t .eq. $pwr)  call emit1 (_pwr_r)
            if (t .eq. $eq)   call emit1 (_eq_r)
            if (t .eq. $ne)   call emit1 (_ne_r)
            if (t .eq. $gt)   call emit1 (_gt_r)
            if (t .eq. $ge)   call emit1 (_ge_r)
            if (t .eq. $lt)   call emit1 (_lt_r)
            if (t .eq. $le)   call emit1 (_le_r)
            esp = esp - 1
            if (c .eq. BINARY_ARITHMETIC_OP) then
               type(esp) = REALTYPE
            else
               type(esp) = LOGTYPE
            end if
         else if (type(esp).eq.INTTYPE .and. type(esp-1).eq.INTTYPE) then
            if (t .eq. $add)  call emit1 (_add_i)
            if (t .eq. $sub)  call emit1 (_sub_i)
            if (t .eq. $mult) call emit1 (_mult_i)
            if (t .eq. $div)  call emit1 (_div_i)
            if (t .eq. $pwr)  call emit1 (_pwr_i)
            if (t .eq. $eq)   call emit1 (_eq_i)
            if (t .eq. $ne)   call emit1 (_ne_i)
            if (t .eq. $gt)   call emit1 (_gt_i)
            if (t .eq. $ge)   call emit1 (_ge_i)
            if (t .eq. $lt)   call emit1 (_lt_i)
            if (t .eq. $le)   call emit1 (_le_i)
            esp = esp - 1
            if (c .eq. BINARY_ARITHMETIC_OP) then
               type(esp) = INTTYPE
            else
               type(esp) = LOGTYPE
            end if
         else
            call perror ('operator not allowed on operand data type'//NULL)
         end if
      else if (c .eq. UNARY_LOGICAL_OP) then
         if (aorv(esp) .eq. ADDRESS) then
            call emit1 (_val)
            aorv(esp) = VALUE
         end if
         if (type(esp) .eq. LOGTYPE) then
             call emit1 (_not)
         else
             call perror ('logical operand type required'//NULL)
         end if
      else if (c .eq. BINARY_LOGICAL_OP) then
         if (aorv(esp) .eq. ADDRESS) then
            call emit1 (_val)
            aorv(esp) = VALUE
         end if
         if (aorv(esp-1) .eq. ADDRESS) then
            call emit1 (_val2)
            aorv(esp-1) = VALUE
         end if
         if (type(esp) .eq. LOGTYPE .and. type(esp-1) .eq. LOGTYPE) then
             if (t .eq. $and) call emit1 (_and)
             if (t .eq. $or) call emit1 (_or)
             esp = esp - 1
         else
             call perror ('logical operand types required'//NULL)
         end if
      else if (c .eq. ASSIGN_OP) then
         if (aorv(esp-1) .ne. ADDRESS) then
            call perror ('object of assign must be an address'//NULL)
         end if
         if (type(esp-1) .eq. STRTYPE) then
            if (type(esp) .eq. STRTYPE) then
               call emit1 (_asns)
            else
               call perror ('string assignment type mismatch'//NULL)
            end if
            esp = esp - 1
         else
            if (aorv(esp) .eq. ADDRESS) then
               call emit1 (_val)
               aorv(esp) = VALUE
            end if
            if (type(esp-1) .eq. INTTYPE) then
               if (type(esp) .eq. INTTYPE) then
                  call emit1 (_asnv)
               else if (type(esp) .eq. REALTYPE) then
                  call emit1 (_int)
                  call emit1 (_asnv)
               else
                  call perror ('integer assignment type mismatch'//NULL)
               end if
            else if (type(esp-1) .eq. REALTYPE) then
               if (type(esp) .eq. INTTYPE) then
                  call emit1 (_flt)
                  call emit1 (_asnv)
               else if (type(esp) .eq. REALTYPE) then
                  call emit1 (_asnv)
               else
                  call perror ('real assignment type mismatch'//NULL)
               end if
            else if (type(esp-1) .eq. LOGTYPE) then
               if (type(esp) .eq. LOGTYPE) then
                  call emit1 (_asnv)
               else
                  call perror ('logical assignment type mismatch'//NULL)
               end if
            else
               call perror ('compiler error on assign'//NULL)
            end if
            esp = esp - 1
            aorv(esp) = VALUE
         end if
      end if

      return
      end
