! shell.lex  -  tokens for shell command line

#include shell.mac

! shell metacharacters

$in      = <
$out     = >
$append  = >>
$pipe    = \|

! internal commands

$exit    = ( (e|E)(x|X)(i|I)(t|T) | (l|L)(o|O) )
$prompt  = (p|P)(r|R)(o|O)(m|M)(p|P)(t|T)
$shell   = (s|S)(h|H)(e|E)(l|L)(l|L)

! other tokens

! all printable nonblank characters except shell metacharacters and quotes
#define pnm (\\h21|[\\h23-\\h26]|[\\h28-\\h3B]|\\h3D|[\\h3F-\\h7B]|\\h7D|\\h7E)
! all printable characters except quote
#define    pnq   ( [\\h20-\\h26] | [\\h28-\\h7E] )
! all printable characters except DQUOTE
#define    pnd   ( [\\h20-\\h21] | [\\h23-\\h7E] )

#quote

$quote    =  ' {pnq} ' { '{pnq}' }
$dquote   =  " {pnd} " { "{pnd}" }
$token    =  pnm {pnm}
$newline  =  \n
