! spl  -  simple programming language

      program spl
      #include           global.def
      #include           options.cmn
      #include           spl.mac
      integer            argc, fopen, u, i, j, basefp, basebp, lex, t
      character*(MAXSTR) argv (MAXARGS), infile, upper, token
      logical            parse, calc, fnflag

      call ioinit ()
      call getargs (argc, argv)
      fnflag = .false.
      calcflag = .false.
      listflag = .false.
      codeflag = .false.
      traceflag = .false.
      do i = 1, argc
         j = index (argv(i), NULL)
         if (argv(i)(1:1) .eq. QUALIFIER) then
            argv(i) = upper(argv(i))
            if (index(argv(i)(2:j),'C') .gt. 0) calcflag = .true.
            if (index(argv(i)(2:j),'L') .gt. 0) listflag = .true.
            if (index(argv(i)(2:j),'M') .gt. 0) codeflag = .true.
            if (index(argv(i)(2:j),'T') .gt. 0) traceflag = .true.
         else
            if (fnflag) then
               call fputstr (STDERR,'syntax: spl [infile] [-options]'//EOL)
               call fputstr (STDERR,'options: -L   produce listing'//EOL)
               call fputstr (STDERR,'         -M   list machine code'//EOL)
               call fputstr (STDERR,'         -T   trace execution'//EOL)
               call fputstr (STDERR,'         -C   calculator mode'//EOL)
               stop ' '
            else
               fnflag = .true.
               if (index(argv(i)(1:j), '.') .gt. 0) then
                  infile = argv(i)
               else
                  infile = argv(i)(1:j-1) // '.SPL' // NULL
               end if
            end if
         end if
      end do

      if (fnflag) then
         if (fopen (u, infile, IOREAD) .eq. IOERROR) then
            call fputstr (STDERR, 'cannot open '//infile)
            call fputstr (STDERR, ' for input'//EOL)
            stop 'aborted.'
         end if
      else
         u = STDIN
      end if
      call ppinit (u)
      call syminit ()
      call initfunc ()


      if (calcflag) then
         do while (lex(t,token) .ne. $eof)
            if (calc (t, token, basefp, basebp)) then
               call vexec (basefp, basebp)
            else
               call fputstr (STDERR, 'statement ignored'//EOL)
            end if
         end do
      else
         if (parse (basefp, basebp)) then
            call vexec (basefp, basebp)
         else
            stop 'aborted.'
         end if
      end if

      end
