! stmtparse  -  parse statements within program units

      subroutine stmtparse (t, token)
      integer        t
      character*(*)  token
      #include       global.def
      #include       spl.mac
      #include       vm.mac
      #include       vstate.cmn
      #include       parse.cmn
      integer        lex, av, exprtype
      logical        exprparse, done

      if (t .eq. $id) then                !assignment or function call
         if (exprparse (t, token, av, exprtype)) call emit1 (_pop)
      else if (t .eq. $int .or. t .eq. $real .or. 
     &         t .eq. $log .or. t .eq. $char) then
         call declist (t)
      else if (t .eq. $while) then        !while lexpr
         nsp = nsp + 1
         nest(nsp) = $while
         pc1(nsp) = pc
         if (exprparse (t, token, av, exprtype)) then
            if (exprtype .ne. LOGTYPE) then
               call perror ('logical valued expression required'//NULL)
            end if
         end if
         if (av .eq. ADDRESS) call emit1 (_val)
         call emit2 (_jf, 0, INTTYPE)
         pc2(nsp) = pc - 1
      else if (t .eq. $endwhile) then     !end while
         if (nest(nsp) .eq. $while) then
            call emit2 (_jmp, pc1(nsp), INTTYPE)
            mem(pc2(nsp)) = pc
         else
            call perror ('improper nesting of while statement'//NULL)
         end if
         nsp = nsp - 1
         t = lex(t,token)
      else if (t .eq. $repeat) then       !repeat
         nsp = nsp + 1
         nest(nsp) = $until
         pc1(nsp) = pc
         t = lex(t,token)
      else if (t .eq. $until) then        !until lexpr
         if (nest(nsp) .ne. $until) then
            call perror ('improper nesting of UNTIL statement'//NULL)
         end if
         if (exprparse (t, token, av, exprtype)) then
            if (exprtype .ne. LOGTYPE) then
               call perror ('logical valued expression required'//NULL)
            end if
         end if
         if (av .eq. ADDRESS) call emit1 (_val)
         call emit2 (_jf, pc1(nsp), INTTYPE)
         nsp = nsp - 1
      else if (t .eq. $if) then           !if lexpr
         nsp = nsp + 1
         nest(nsp) = $if
         if (exprparse (t, token, av, exprtype)) then
            if (exprtype .ne. LOGTYPE) then
               call perror ('logical valued expression required'//NULL)
            end if
         end if
         if (av .eq. ADDRESS) call emit1 (_val)
         call emit2 (_jf, 0, INTTYPE)
         pc2(nsp) = pc - 1
         pc1(nsp) = pc2(nsp)        !in case of no else or elseif
      else if (t .eq. $elseif) then        !else if lexpr
         if (nest(nsp) .ne. $if .and. nest(nsp) .ne. $elseif) then
            call perror ('else if without if'//NULL)
         end if
         call emit2 (_jmp, 0, INTTYPE)
         pc1(nsp) = pc - 1
         mem(pc2(nsp)) = pc
         nsp = nsp + 1
         nest(nsp) = $elseif
         if (exprparse (t, token, av, exprtype)) then
            if (exprtype .ne. LOGTYPE) then
               call perror ('logical valued expression required'//NULL)
            end if
         end if
         if (av .eq. ADDRESS) call emit1 (_val)
         call emit2 (_jf, 0, INTTYPE)
         pc2(nsp) = pc - 1
         pc1(nsp) = pc2(nsp)        !in case of no else or elseif
      else if (t .eq. $else) then         !else
         if (nest(nsp) .ne. $if .and. nest(nsp) .ne. $elseif) then
            call perror ('else without matching if'//NULL)
         end if
         call emit2 (_jmp, 0, INTTYPE)
         pc1(nsp) = pc - 1
         mem(pc2(nsp)) = pc
         t = lex(t,token)
      else if (t .eq. $endif) then        !end if
         done = .false.
         do while (.not. done)
            if (nest(nsp) .eq. $if) then
               mem(pc1(nsp)) = pc
               nsp = nsp - 1
               done = .true.
            else if (nest(nsp) .eq. $elseif) then
               mem(pc1(nsp)) = pc
               nsp = nsp - 1
            else
               call perror ('end if without matching if'//NULL)
               done = .true.
            end if
         end do
         t = lex(t,token)
      else if (t .eq. $read) then         !read idlist
         call readstmt (t)
      else if (t .eq. $print) then        !print exprlist
         call printstmt (t)
      else
         call perror ('unrecognized statement'//NULL)
         do while (t .ne. $eol)
            t = lex(t,token)
         end do
      end if

      if (t .ne. $eol) then
         call perror ('unexpected tokens after valid statement'//NULL)
         do while (t .ne. $eol)
            t = lex(t,token)
         end do
      end if

      return
      end
