! vexec  -  execute program for virtual machine

      subroutine vexec (basefp,basebp)
      integer            basefp, basebp
      #include           global.def
      #include           vm.mac
      #include           vstate.cmn
      #include           options.cmn
      integer            CALLSTKSIZE  !max number of nested function calls
      parameter          (CALLSTKSIZE = 8)
      integer            markstack(CALLSTKSIZE), msp
      integer            opcode, i, j, k, addr
      integer            statio, ip
      logical            fgetline, equal, is_ival, is_rval, is_sval
      character*(MAXSTR) itoa, ftoa, doescape, buffer, tracebuf
      character*1        c

      pc = ORIGIN
      fp = basefp
      lbp = basebp
      mem(fp) = 0
      sp = fp + 1
      statio = .true.

      if (traceflag) then
         call fputstr (STDOUT,
     &'  --------- registers ------------    -------- values --------'//EOL)
         call fputstr (STDOUT,
     &'  pc      fp     lp     lbp    sp     pc         sp-1       sp'//EOL)
      end if

! fetch instruction
      #define _fetch 999

 _fetch    continue
      if (traceflag) then
         write (tracebuf, '(6(I5,2x),2(I11),A2)') 
     &         pc, fp, lp, lbp, sp, mem(pc), mem(sp-1), mem(sp), EOL
         call fputstr (STDOUT, tracebuf)
      end if
      opcode = mem(pc)
      pc = pc + 1

! execute instruction
      goto (
     & _add_i,   _add_r,   _sub_i,   _sub_r,   _mult_i,  _mult_r,  
     & _div_i,   _div_r,   _pwr_i,   _pwr_r,   _neg_i,   _neg_r,   
     & _eq_i,    _eq_r,    _ne_i,    _ne_r,    _gt_i,    _gt_r,    
     & _ge_i,    _ge_r,    _lt_i,    _lt_r,    _le_i,    _le_r,    
     & _and,     _or,      _not,     _mark,    _markl,   _call,    
     & _rtn,     _rtns,    _alloc,   _calloc,  _halt,    _push,    
     & _push_r,  _push_l,  _pushl,   _pushlc,  _pushf,   _pop,     
     & _asnv,    _asna,    _asns,    _val,     _val2,    _ixa,     
     & _readln,  _read_i,  _read_r,  _read_l,  _read_s,  _print_i, 
     & _print_r, _print_l, _print_s, _jt,      _jf,      _jmp,     
     & _flt,     _flt2,    _int,     _int2,    _sin,     _cos,     
     & _tan,     _asin,    _acos,    _atan,    _exp,     _log,     
     & _abs_i,   _abs_r,   _cat,     _indx,    _chr,     _ord,     
     & _eqs,     _substr,  _len     
     & ), opcode

      call fputstr (STDERR, 'unknown opcode, pc = '//itoa(pc-1))
      call fputc  (STDERR, NEWLINE)
      return

 _add_i       continue
      mem(sp-1) = mem(sp-1) + mem(sp)
      sp = sp - 1
      goto _fetch

 _add_r       continue
      rmem(sp-1) = rmem(sp-1) + rmem(sp)
      sp = sp - 1
      goto _fetch

 _sub_i       continue
      mem(sp-1) = mem(sp-1) - mem(sp)
      sp = sp - 1
      goto _fetch

 _sub_r       continue
      rmem(sp-1) = rmem(sp-1) - rmem(sp)
      sp = sp - 1
      goto _fetch

 _mult_i      continue
      mem(sp-1) = mem(sp-1) * mem(sp)
      sp = sp - 1
      goto _fetch

 _mult_r      continue
      rmem(sp-1) = rmem(sp-1) * rmem(sp)
      sp = sp - 1
      goto _fetch

 _div_i       continue
      if (mem(sp) .eq. 0) then
         call fputstr (STDERR, 'division by zero at pc = '//itoa(pc))
         call fputc  (STDERR, NEWLINE)
         return
      else
         mem(sp-1) = mem(sp-1) / mem(sp)
      end if
      sp = sp - 1
      goto _fetch

 _div_r       continue
      if (mem(sp) .eq. 0) then
         call fputstr (STDERR, 'division by zero at pc = '//itoa(pc))
         call fputc  (STDERR, NEWLINE)
         return
      else
         rmem(sp-1) = rmem(sp-1) / rmem(sp)
      end if
      sp = sp - 1
      goto _fetch

 _pwr_i       continue
      mem(sp-1) = mem(sp-1) ** mem(sp)
      sp = sp - 1
      goto _fetch

 _pwr_r       continue
      rmem(sp-1) = rmem(sp-1) ** rmem(sp)
      sp = sp - 1
      goto _fetch

 _neg_i       continue
      mem(sp) = -1 * mem(sp)
      goto _fetch

 _neg_r       continue
      rmem(sp) = -1.0 * rmem(sp)
      goto _fetch

 _eq_i        continue
      lmem(sp-1) = (mem(sp-1) .eq. mem(sp))
      sp = sp - 1
      goto _fetch

 _eq_r        continue
      lmem(sp-1) = (rmem(sp-1) .eq. rmem(sp))
      sp = sp - 1
      goto _fetch

 _ne_i        continue
      lmem(sp-1) = (mem(sp-1) .ne. mem(sp))
      sp = sp - 1
      goto _fetch

 _ne_r        continue
      lmem(sp-1) = (rmem(sp-1) .ne. rmem(sp))
      sp = sp - 1
      goto _fetch

 _gt_i        continue
      lmem(sp-1) = (mem(sp-1) .gt. mem(sp))
      sp = sp - 1
      goto _fetch

 _gt_r        continue
      lmem(sp-1) = (rmem(sp-1) .gt. rmem(sp))
      sp = sp - 1
      goto _fetch

 _ge_i        continue
      lmem(sp-1) = (mem(sp-1) .ge. mem(sp))
      sp = sp - 1
      goto _fetch

 _ge_r        continue
      lmem(sp-1) = (rmem(sp-1) .ge. rmem(sp))
      sp = sp - 1
      goto _fetch

 _lt_i        continue
      lmem(sp-1) = (mem(sp-1) .lt. mem(sp))
      sp = sp - 1
      goto _fetch

 _lt_r        continue
      lmem(sp-1) = (rmem(sp-1) .lt. rmem(sp))
      sp = sp - 1
      goto _fetch

 _le_i        continue
      lmem(sp-1) = (mem(sp-1) .le. mem(sp))
      sp = sp - 1
      goto _fetch

 _le_r        continue
      lmem(sp-1) = (rmem(sp-1) .le. rmem(sp))
      sp = sp - 1
      goto _fetch

 _and         continue
      lmem(sp-1) = (lmem(sp-1) .and. lmem(sp))
      sp = sp - 1
      goto _fetch

 _or          continue
      lmem(sp-1) = (lmem(sp-1) .or. lmem(sp))
      sp = sp - 1
      goto _fetch

 _not         continue
      lmem(sp) = (.not. lmem(sp))
      goto _fetch

 _mark        continue
      if (msp .eq. CALLSTKSIZE) then
         call fputstr (STDERR, 'call stack overflow at pc = '//itoa(pc))
         call fputc  (STDERR, NEWLINE)
         return
      end if
      msp = msp + 1
      markstack(msp) = sp
      mem(sp+1) = mem(pc)
      sp = sp + 5
      pc = pc + 1
      goto _fetch

 _markl       continue
      if (msp .eq. CALLSTKSIZE) then
         call fputstr (STDERR, 'call stack overflow at pc = '//itoa(pc))
         call fputc  (STDERR, NEWLINE)
         return
      end if
      msp = msp + 1
      markstack(msp) = sp
      mem(sp+1) = lp + mem(pc)
      sp = sp + 5
      pc = pc + 1
      goto _fetch

 _call        continue
      mem(markstack(msp)+2) = pc + 1
      mem(markstack(msp)+3) = lp
      mem(markstack(msp)+4) = lbp
      mem(markstack(msp)+5) = fp
      fp = markstack(msp) + 5
      lbp = bp
      pc = mem(pc)
      msp = msp - 1
      goto _fetch

 _rtn         continue
      mem(mem(fp-4)) = mem(sp)  !assign function result
      sp = fp-4
      pc = mem(fp-3)
      lp = mem(fp-2)
      bp = lbp
      lbp = mem(fp-1)
      fp = mem(fp)
      goto _fetch

 _rtns        continue
      i = mem(fp-4)            !result address in caller
      j = mem(sp)              !result address in function
      do while (cmem(j:j) .ne. NULL)
         cmem(i:i) = cmem(j:j)
         i = i + 1
         j = j + 1
      end do
      cmem(i:i) = NULL
      sp = fp-4
      pc = mem(fp-3)
      lp = mem(fp-2)
      bp = lbp
      lbp = mem(fp-1)
      fp = mem(fp)
      goto _fetch

 _alloc       continue
      lp = sp + 1
      sp = lp + mem(pc)
      pc = pc + 1
      goto _fetch

 _calloc      continue
      bp = lbp + mem(pc)
      pc = pc + 1
      goto _fetch

 _halt        continue
      call fflush (STDOUT)  !flush output buffer
      return
      !goto _fetch

 _push        continue
      sp = sp + 1
      mem(sp) = mem(pc)
      pc = pc + 1
      goto _fetch

 _push_r      continue
      sp = sp + 1
      rmem(sp) = rmem(pc)
      pc = pc + 1
      goto _fetch

 _push_l      continue
      sp = sp + 1
      lmem(sp) = lmem(pc)
      pc = pc + 1
      goto _fetch

 _pushl       continue
      sp = sp + 1
      mem(sp) = lp + mem(pc)
      pc = pc + 1
      goto _fetch

 _pushlc      continue
      sp = sp + 1
      mem(sp) = lbp + mem(pc)
      pc = pc + 1
      goto _fetch

 _pushf       continue
      sp = sp + 1
      mem(sp) = mem(fp+mem(pc))
      pc = pc + 1
      goto _fetch

 _pop         continue
      sp = sp - 1
      goto _fetch

 _asnv        continue
      mem(mem(sp-1)) = mem(sp)
      mem(sp-1) = mem(sp)
      sp = sp - 1
      goto _fetch

 _asna        continue
      mem(mem(sp)) = mem(sp-1)
      mem(sp-1) = mem(sp)
      sp = sp - 1
      goto _fetch

 _asns        continue
      i = mem(sp-1)
      j = mem(sp)
      do while (cmem(j:j) .ne. NULL)
         cmem(i:i) = cmem(j:j)
         i = i + 1
         j = j + 1
      end do
      cmem(i:i) = NULL
      sp = sp - 1
      goto _fetch

 _val         continue
      mem(sp) = mem(mem(sp))
      goto _fetch

 _val2        continue
      mem(sp-1) = mem(mem(sp-1))
      goto _fetch

 _ixa         continue
      mem(sp-1) = mem(sp-1) + mem(sp)
      sp = sp - 1
      goto _fetch

 _readln      continue
      statio = fgetline (STDIN, cmem(INPUT_ORIGIN:))
      sp = sp + 1
      lmem(sp) = statio
      ip = INPUT_ORIGIN
      goto _fetch

 _read_i      continue
      if (statio) then
         if (.not. is_ival (mem(mem(sp)), cmem, ip)) then
            call fputstr (STDERR, 
     &      'integer input error at pc = '//itoa(pc-1))
         call fputc  (STDERR, NEWLINE)
         end if
      else
         call fputstr (STDERR, 
     &   'integer read past eof at pc = '//itoa(pc-1))
         call fputc  (STDERR, NEWLINE)
      end if
      goto _fetch

 _read_r      continue
      if (statio) then
         if (.not. is_rval (rmem(mem(sp)), cmem, ip)) then
            call fputstr (STDERR, 
     &      'real input error at pc = '//itoa(pc-1))
            call fputc  (STDERR, NEWLINE)
         end if
      else
         call fputstr (STDERR, 
     &   'real read past eof at pc = '//itoa(pc-1))
         call fputc  (STDERR, NEWLINE)
      end if
      goto _fetch

 _read_l      continue
      if (statio) then
         do while (cmem(ip:ip) .eq. BLANK)
            ip = ip + 1
         end do
         c = cmem(ip:ip)
         if (c .eq. 't' .or. c .eq. 'T' .or. c .eq. '1') then
            lmem(mem(sp)) = .true.
         else if (c .eq. 'f' .or. c .eq. 'F' .or. c .eq. '0') then
            lmem(mem(sp)) = .false.
         else
            call fputstr (STDERR, 
     &      'logical input error at pc = '//itoa(pc-1))
            call fputc  (STDERR, NEWLINE)
         end if
      else
         call fputstr (STDERR, 
     &   'logical read past eof at pc = '//itoa(pc-1))
         call fputc  (STDERR, NEWLINE)
      end if
      goto _fetch

 _read_s      continue
      if (statio) then
         if (is_sval (buffer, cmem, ip)) then
            buffer = doescape (buffer)
            i = 1
            j = mem(sp)
            do while (buffer(i:i) .ne. NULL)
               cmem(j:j) = buffer(i:i)
               i = i + 1
               j = j + 1
            end do
         else
            call fputstr (STDERR, 
     &      'character input error at pc = '//itoa(pc-1))
            call fputc  (STDERR, NEWLINE)
         end if
      else
         call fputstr (STDERR, 
     &   'character read past eof at pc = '//itoa(pc-1))
         call fputc  (STDERR, NEWLINE)
      end if
      goto _fetch

 _print_i     continue
      call fputstr (STDOUT, itoa(mem(sp)))
      sp = sp - 1
      goto _fetch

 _print_r     continue
      call fputstr (STDOUT, ftoa(rmem(sp)))
      sp = sp - 1
      goto _fetch

 _print_l     continue
      if (lmem(sp)) then
         call fputstr (STDOUT, 'true'//NULL)
      else
         call fputstr (STDOUT, 'false'//NULL)
      end if
      sp = sp - 1
      goto _fetch

 _print_s     continue
      call fputstr (STDOUT, cmem(mem(sp):))
      sp = sp - 1
      goto _fetch

 _jt          continue
      if (lmem(sp)) then
         pc = mem(pc)
      else
         pc = pc + 1
      end if
      sp = sp - 1
      goto _fetch

 _jf          continue
      if (.not. lmem(sp)) then
         pc = mem(pc)
      else
         pc = pc + 1
      end if
      sp = sp - 1
      goto _fetch

 _jmp         continue
      pc = mem(pc)
      goto _fetch

 _flt         continue
      rmem(sp) = real(mem(sp))
      goto _fetch

 _flt2        continue
      rmem(sp-1) = real(mem(sp-1))
      goto _fetch

 _int         continue
      mem(sp) = int(rmem(sp))
      goto _fetch

 _int2        continue
      mem(sp-1) = int(rmem(sp-1))
      goto _fetch

 _sin         continue
      rmem(sp) = sin(rmem(sp))
      goto _fetch

 _cos         continue
      rmem(sp) = cos(rmem(sp))
      goto _fetch

 _tan         continue
      rmem(sp) = tan(rmem(sp))
      goto _fetch

 _asin        continue
      rmem(sp) = asin(rmem(sp))
      goto _fetch

 _acos        continue
      rmem(sp) = acos(rmem(sp))
      goto _fetch

 _atan        continue
      rmem(sp) = atan(rmem(sp))
      goto _fetch

 _exp         continue
      rmem(sp) = exp(rmem(sp))
      goto _fetch

 _log         continue
      rmem(sp) = log(rmem(sp))
      goto _fetch

 _abs_i       continue
      mem(sp) = iabs(mem(sp))
      goto _fetch

 _abs_r       continue
      rmem(sp) = abs(rmem(sp))
      goto _fetch

 _cat         continue
      i = mem(sp-1)
      do while (cmem(i:i) .ne. NULL)
         i = i + 1
      end do
      j = mem(sp)
      do while (cmem(j:j) .ne. NULL)
         cmem(i:i) = cmem(j:j)
         i = i + 1
         j = j + 1
      end do
      cmem(i:i) = NULL
      sp = sp - 1
      goto _fetch

 _indx        continue
      i = mem(sp)
      do while (cmem(i:i) .ne. NULL)
         i = i + 1
      end do
      j = mem(sp-1)
      do while (cmem(j:j) .ne. NULL)
         j = j + 1
      end do
      mem(sp-1) = index(cmem(mem(sp-1):j-1),cmem(mem(sp):i-1))
      sp = sp - 1
      goto _fetch

 _chr         continue
      cmem(mem(sp-1):mem(sp-1)+1) = char(mem(sp))//NULL
      sp = sp - 1
      goto _fetch

 _ord         continue
      mem(sp) = ichar(cmem(mem(sp):mem(sp)))
      goto _fetch

 _eqs         continue
      lmem(sp-1) = equal(cmem(mem(sp):),cmem(mem(sp-1):))
      sp = sp - 1
      goto _fetch

 _substr      continue
      j = mem(sp)                  !position 2
      i = mem(sp-1)                !position 1
      if (j .lt. i) then
         call fputstr (STDERR, 'substring range error at pc = '//itoa(pc))
         call fputc (STDERR, NEWLINE)
      end if
      k = mem(sp-2)                !address of string argument
      addr = mem(sp-3)             !address of result
      cmem(addr:addr+j-i+1) = cmem(k+i-1:k+j-1)//NULL
      sp = sp - 3
      goto _fetch

 _len         continue
      i = mem(sp)
      j = 0
      do while (cmem(i:i) .ne. NULL)
         i = i + 1
         j = j + 1
      end do
      mem(sp) = j
      goto _fetch

      end
