! fortran.lex  -  lexgen input for fortran-like tokens

! preliminaries
#define   letter       [a-z]
#define   digit        [0-9]
#define   unsigned_int [0-9]{[0-9]}
#define   dec_num      ([0-9]{[0-9]}.{[0-9]}|{[0-9]}.[0-9]{[0-9]})
#define   alpha        ([a-z]|[0-9])
! all printable characters except quote
#define   pnq          ([\\h20-\\h26]|[\\h28-\\h7E])

! define token return values
#include token.mac

! define token regular expressions

! keywords
$assign       =  assign
$backspace    =  backspace
$blockdata    =  block {\b} data
$call         =  call
$close        =  close
$char         =  character
$cmn          =  common
$cmplx        =  complex
$cont         =  continue
$data         =  data
$dim          =  dimension
$do           =  do
$while        =  do {\b} while
$dblprec      =  double {\b} precision
$else         =  else
$elif         =  else {\b} if
$end          =  end
$enddo        =  end {\b} do
$endif        =  end {\b} if
$endfile      =  endfile
$entry        =  entry
$equiv        =  equivalence
$extrn        =  external
$fmt          =  format
$func         =  function
$goto         =  go {\b} to
$if           =  if
$implicit     =  implicit
$include      =  include
$inquire      =  inquire
$int          =  integer
$intrinsic    =  intrinsic
$log          =  logical
$open         =  open
$param        =  parameter
$pause        =  pause
$print        =  print
$prog         =  program
$read         =  read
$real         =  real
$rtn          =  return
$rewind       =  rewind
$save         =  save
$stop         =  stop
$sub          =  subroutine
$write        =  write
$then         =  then

! punctuation tokens
$lparen      =  \(
$rparen      =  \)
$colon       =  :
$comma       =  ,

! numbers
$intnum      =  unsigned_int
$realnum     =  (dec_num | dec_num E (+|-|) unsigned_int)

! identifiers
$id          =  letter {( letter | digit | $ | _ )}

! literal strings
$string      =  ' {pnq} ' { '{pnq}' }

! operators
! binary arithmetic operators
$plus        =  +
$minus       =  -
$mult        =  *
$div         =  /
$exp         =  **
! binary relational operators
$eq          =  .eq.
$ne          =  .ne.
$gt          =  .gt.
$ge          =  .ge.
$lt          =  .lt.
$le          =  .le.
$and         =  .and.
$or          =  .or.
$eqv         =  .eqv.
$neqv        =  .neqv.
! unary logical operator
$not         =  .not.
! logical constants
$true        =  .true.
$false       =  .false.
! character string concatenation
$concat      =  //
! assignment operator
$assignop    =  =

! statement terminator
$eol         =  \n
